PPluginModuleManager Class Reference

`#include <pluginmgr.h>`

Inheritance diagram for PPluginModuleManager:

## Public Types

typedef PDictionary< PString, PDynaLink > | PluginListType
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Public Member Functions

| PPluginModuleManager (const char *signatureFunctionName, PPluginManager *pluginMgr=NULL)
PBoolean | LoadPlugin (const PString &fileName)
void | LoadPluginDirectory (const PDirectory &directory)
virtual void | OnLoadPlugin (PDynaLink &, INT)
virtual PluginListType | GetPluginList () const
virtual void | OnStartup ()
virtual void | OnShutdown ()
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions

| PDECLARE_NOTIFIER (PDynaLink, PPluginModuleManager, OnLoadModule)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PluginListType | pluginDLLs
const char * | signatureFunctionName
PPluginManager * | pluginMgr

## Additional Inherited Members

Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Member Typedef Documentation

typedef PDictionary<PString, PDynaLink> PPluginModuleManager::PluginListType

## Constructor & Destructor Documentation

PPluginModuleManager::PPluginModuleManager | ( | const char * | signatureFunctionName,
|  | PPluginManager * | pluginMgr = `NULL`
| ) |  |

## Member Function Documentation

virtual PluginListType PPluginModuleManager::GetPluginList | ( |  | ) | const

inline virtual

References pluginDLLs.

PBoolean PPluginModuleManager::LoadPlugin | ( | const PString & | fileName | ) |

inline

References PPluginManager::LoadPlugin(), and pluginMgr.

void PPluginModuleManager::LoadPluginDirectory | ( | const PDirectory & | directory | ) |

inline

References PPluginManager::LoadPluginDirectory(), and pluginMgr.

virtual void PPluginModuleManager::OnLoadPlugin | ( | PDynaLink & | ,
|  | INT |
| ) |  |

inline virtual

virtual void PPluginModuleManager::OnShutdown | ( |  | ) |

inline virtual

virtual void PPluginModuleManager::OnStartup | ( |  | ) |

inline virtual

PPluginModuleManager::PDECLARE_NOTIFIER | ( | PDynaLink | ,
|  | PPluginModuleManager | ,
|  | OnLoadModule |
| ) |  |

protected

## Member Data Documentation

PluginListType PPluginModuleManager::pluginDLLs

protected

Referenced by GetPluginList().

PPluginManager* PPluginModuleManager::pluginMgr

protected

Referenced by LoadPlugin(), and LoadPluginDirectory().

const char* PPluginModuleManager::signatureFunctionName

protected

The documentation for this class was generated from the following file:

- pluginmgr.h